# Cloudinary source migrate path

## Migration path Cloudinary from 2.x to 3.x

1. Update a module with composer.
2. Update the usages in custom code for the following services
   1. cloudinary_media_library_widget.asset_generator to cloudinary_sdk.asset_helper
3. Create a new media types with Cloudinary source.
   1. You can use the same name but another machine name like **cloudinary_image** -> **cloudinary_media_image**
   2. Deprecate old cloudinary media types by adding **deprecated** prefix. In this case you can visually see the difference between new and old media entities.
4. If you use focal_point module, please apply the following patch
   1. https://www.drupal.org/project/focal_point/issues/3343645
5. Configure view modes for new media types to output the asset in the way you need.
6. Apply a custom htaccess redirect rule if you use DRI formatter. See this [README.md](..%2Fcloudinary_media_library_widget%2FREADME.md).
7. Update media reference fields to use new bundles. Old media types can be unchecked.
8. Enable this module to migrate deprecated media entities to new bundles + migration of entity reference field values.
   1. **hook_deploy_NAME()** is used for migration, so it will be automatically performed by using a command **drush deploy:hook** in your deployment script.
   2. Implement a new **hook_cloudinary_source_migrate_media_name_alter($name, $asset)** to generate a media name for your new media items.
   3. Perform migration.
   4. During migration there might be some errors from cloudinary API side e.g. resource not found, do not worry about the errors as we try to load asset again but with fallback type.
9. Test migration.
10. Release to all environments.
11. Remove all media entities of old bundles.
12. Clean up old media types with all related configs.
13. Uninstall this module.

## Important

This module will be removed in the next major version 4.x. Please uninstall this module before upgrading to 4.x.
